// C Source File
// Created 12/22/04; 11:31:34 AM

#ifndef BACKDROP_C_DEFINED

       #define BACKDROP_C_DEFINED

#include <sprites.h>
#include <compat.h>
#include <graph.h>

#include <alloc.h>
#include <stdlib.h>

#include "glob_var.h"

/*

 // constants from Menu.c

#define MAX_BACK_GROUNDS   6
#define BACK_GROUND_1      "TREES"
#define BACK_GROUND_2      "FLAKES"
#define BACK_GROUND_3      "FISH"
#define BACK_GROUND_4      "BRICKS"
#define BACK_GROUND_5      "MONSTERS"
#define BACK_GROUND_6      "NONE   "

*/

//00000000000000000000000000000000000000000000000000000000000000000000000000

#define BACKGROUND_MAX_IMAGES      6
#define BACKGROUND_SPRITE16_SIZE   32
#define BACKGROUND_SPRITE16_WIDTH  16
#define BACKGROUND_SPRITE16_HEIGHT 16

struct Sprite16Data 
{
    unsigned char Data[BACKGROUND_SPRITE16_SIZE];
};


//00000000000000000000000000000000000000000000000000000000000000000000000000

static struct Sprite16Data MySprite16Data[] =
   {
        // trees
          {
        128, 3,
        192, 5,
        48, 14,
        152, 12,
        16, 16,
        8, 61,
        76, 24,
        8, 34,
        36, 112,
        20, 33,
        2, 100,
        188, 49,
        224, 15,
        64, 1,
        192, 1,
        0, 0 
          },

        // flakes
      {
        0, 0,
        132, 96,
        204, 60,
        216, 19,
        104, 8,
        200, 252,
        144, 102,
        240, 17,
        72, 23,
        56, 45,
        172, 53,
        98, 5,
        96, 10,
        48, 12,
        16, 8,
        16, 0 
          },
          
        // fish

      {
        0, 1,
        0, 3,
        128, 2,
        128, 4,
        66, 11,
        206, 20,
        82, 32,
        36, 98,
        12, 53,
        20, 50,
        12, 96,
        52, 96,
        206, 29,
        130, 3,
        192, 0,
        0, 0 
          },
          
        // bricks

       {
        8, 130,
        8, 130,
        8, 130,
        255, 255,
        64, 16,
        64, 16,
        64, 16,
        255, 255,
        8, 130,
        8, 130,
        8, 130,
        255, 255,
        32, 16,
        32, 16,
        32, 16,
        255, 255 
          },

       // monsters

        {
        224, 7,
        24, 24,
        44, 36,
        46, 116,
        74, 90,
        95, 186,
        191, 189,
        225, 199,
        135, 225,
        139, 177,
        123, 170,
        238, 95,
        174, 74,
        172, 38,
        188, 30,
        224, 7 
          },
          
        // blank
        
        { 
           0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
           0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        }
       
   };

//00000000000000000000000000000000000000000000000000000000000000000000000000

void InitializeBackGround ( void *BackGroundLayer, short BackGroundIndex,
                            struct PlayField* MyPlayFieldv );
void ClearBackGroundTextArea ( void *BackGroundLayer, 
                               struct PlayField* MyPlayField );


//00000000000000000000000000000000000000000000000000000000000000000000000000

void InitializeBackGround ( void *BackGroundLayer, short BackGroundIndex,
                            struct PlayField* MyPlayField )
{

     unsigned short *SpritePointer;
     unsigned short X, Y, PlayFieldClearingXDisplacement;
     
     if ( 0 <= BackGroundIndex && BackGroundIndex < BACKGROUND_MAX_IMAGES )
     
          SpritePointer = (unsigned short*)MySprite16Data[BackGroundIndex].Data; 
     else
          SpritePointer = NULL;
     
     
     memset ( BackGroundLayer, 0, LCD_SIZE );
        
     if ( SpritePointer != NULL )
     
     for ( Y = 0; Y < LCD_HEIGHT; Y += BACKGROUND_SPRITE16_HEIGHT )
        for ( X = 0; X < LCD_WIDTH; X += BACKGROUND_SPRITE16_WIDTH )
             
             Sprite16 ( X, Y, BACKGROUND_SPRITE16_HEIGHT, 
                        SpritePointer,
                        BackGroundLayer,
                        SPRT_OR );
                        
     // erase the background images in the play area
     
   SpritePointer = (unsigned short*)MySprite16Data[5].Data;

   for ( Y = 0; Y < LCD_HEIGHT; Y += BACKGROUND_SPRITE16_HEIGHT )
     {
      for ( X = PLAYFIELD_WALL_1_X * CELL_WIDTH_PIXELS ; 
            X < PLAYFIELD_WALL_2_X * CELL_WIDTH_PIXELS ;
            X += BACKGROUND_SPRITE16_WIDTH )
           
           Sprite16 ( X, Y, BACKGROUND_SPRITE16_HEIGHT, 
                      SpritePointer,
                      BackGroundLayer,
                      SPRT_AND );
           
      PlayFieldClearingXDisplacement = PLAYFIELD_WALL_2_X * CELL_WIDTH_PIXELS
                                     - BACKGROUND_SPRITE16_WIDTH ;  
       
                  Sprite16 ( X, Y, BACKGROUND_SPRITE16_HEIGHT, 
                      SpritePointer,
                      BackGroundLayer,
                      SPRT_AND );       
      
     } 
     
   ClearBackGroundTextArea ( BackGroundLayer, MyPlayField );
}

//00000000000000000000000000000000000000000000000000000000000000000000000000

void ClearBackGroundTextArea ( void *BackGroundLayer, 
                               struct PlayField* MyPlayField )
{
     static const char BLANK_TEXT[] = "      ";
     
     DrawText ( FIXED_SCORE_X, FIXED_SCORE_Y, BLANK_TEXT, 
                BackGroundLayer, SPRT_AND );
                
     DrawText ( FIXED_SCORE_X, FIXED_SCORE_Y + SPRITE8_HEIGHT, 
                BLANK_TEXT, 
                BackGroundLayer, SPRT_AND );

     DrawText ( MyPlayField->LevelX, MyPlayField->LevelY, BLANK_TEXT, 
                BackGroundLayer, SPRT_AND );

     DrawText ( MyPlayField->LevelX, MyPlayField->LevelY + SPRITE8_HEIGHT,
                BLANK_TEXT, 
                BackGroundLayer, SPRT_AND );

     DrawText ( MyPlayField->LinesCompletedX, MyPlayField->LinesCompletedY, 
                BLANK_TEXT, 
                BackGroundLayer, SPRT_AND );
                
     DrawText ( MyPlayField->LinesCompletedX, 
                MyPlayField->LinesCompletedY + SPRITE8_HEIGHT,
                BLANK_TEXT, 
                BackGroundLayer, SPRT_AND );
}                               

//00000000000000000000000000000000000000000000000000000000000000000000000000

#endif
