// C Source File
// Created 12/21/04; 7:37:48 PM

#ifndef DRAWTEXT_DEFINED
    
      #define DRAWTEXT_DEFINED

#include <graph.h>
#include <sprites.h>
#include <kbd.h>
#include <stdio.h>

#define DRAWTEXT_CHARACTER_RANGE 'Z' - ' ' + 1
#define DRAWTEXT_START_CHARACTER ' '
#define DRAWTEXT_WIDTH   6
#define DRAWTEXT_SPRITE_HEIGHT  8

//00000000000000000000000000000000000000000000000000000000000000000000000000

struct ByteStruct
{
   short b1: 1;
   short b2: 1;
   short b3: 1;
   short b4: 1;
   short b5: 1;
   short b6: 1;
   short b7: 1;
   short b8: 1;
};

union ByteReverse  
    {
       unsigned char Byte;
       
       struct ByteStruct ByteBits;  
    };

struct ASCII_Sprite
    {
       unsigned char Data[8];
    };
    
//00000000000000000000000000000000000000000000000000000000000000000000000000

static struct ASCII_Sprite ASCII_Array[DRAWTEXT_CHARACTER_RANGE] = 
    {
 
        // the space character
        
      { 0, 0, 0, 0, 0, 0, 0, 0 },
        
        // the characters in gap between the space character and 0 
        // are not displayed
        
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
    
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
    
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },
      { 252, 252, 252, 252, 252, 252, 252, 252 },

 /*  Number_0 */   {
        0,
        48,
        72,
        88,
        104,
        72,
        48,
        0
          },

 /*  Number_1 */   {
        0,
        48,
        16,
        16,
        16,
        16,
        16,
        0
          },

 /*  Number_2 */   {
        0,
        112,
        16,
        112,
        64,
        64,
        112,
        0 
          },

 /*  Number_3 */   {
        0,
        120,
        8,
        8,
        120,
        8,
        120,
        0 
          },

 /*  Number_4 */   {
        0,
        72,
        72,
        72,
        120,
        8,
        8,
        0 
          },

 /*  Number_5 */   {
        0,
        120,
        64,
        120,
        8,
        8,
        48,
        0 
          },

 /*  Number_6 */   {
        0,
        56,
        64,
        64,
        120,
        72,
        112,
        0 
          },

 /*  Number_7 */   {
        0,
        120,
        8,
        16,
        48,
        32,
        32,
        0 
          },

 /*  Number_8 */   {
        0,
        120,
        72,
        72,
        120,
        72,
        120,
        0 
          },

 /*  Number_9 */   {
        0,
        120,
        72,
        120,
        8,
        8,
        120,
        0 
          },

   // the gap between 9 and A on ASCII List not displayed

    { 252, 252, 252, 252, 252, 252, 252, 252 },
    { 252, 252, 252, 252, 252, 252, 252, 252 },
    { 252, 252, 252, 252, 252, 252, 252, 252 },
    { 252, 252, 252, 252, 252, 252, 252, 252 },
    { 252, 252, 252, 252, 252, 252, 252, 252 },
    { 252, 252, 252, 252, 252, 252, 252, 252 },
    { 252, 252, 252, 252, 252, 252, 252, 252 },

 /*  Letter_A */   {
        0,
        48,
        120,
        72,
        120,
        72,
        72,
        0
          },

 /*  Letter_B */   {
        0,
        112,
        80,
        80,
        120,
        72,
        120,
        0
          },

 /*  Letter_C */   {
        0,
        120,
        64,
        64,
        64,
        64,
        120,
        0 
          },

 /*  Letter_D */   {
        0,
        112,
        88,
        72,
        72,
        88,
        112,
        0 
          },

 /*  Letter_E */   {
        0,
        120,
        64,
        120,
        64,
        64,
        120,
        0 
          },

 /*  Letter_F */   {
        0,
        120,
        64,
        120,
        64,
        64,
        64,
        0 
          },

 /*  Letter_G */   {
        0,
        120,
        64,
        64,
        88,
        72,
        120,
        0
          },

 /*  Letter_H */   {
        0,
        72,
        72,
        72,
        120,
        72,
        72,
        0
          },

 /*  Letter_I */   {
        0,
        56,
        16,
        16,
        16,
        16,
        56,
        0 
          },

 /*  Letter_J */   {
        0,
        56,
        16,
        16,
        80,
        80,
        112,
        0 
          },

 /*  Letter_K */   {
        0,
        72,
        88,
        112,
        96,
        112,
        88,
        0 
          },

 /*  Letter_L */   {
        0,
        64,
        64,
        64,
        64,
        64,
        120,
        0 
          },

 /*  Letter_M */   {
        0,
        248,
        168,
        168,
        168,
        168,
        168,
        0 
          },

 /*  Letter_N */   {
        0,
        200,
        232,
        168,
        152,
        152,
        136,
        0 
          },

 /*  Letter_O */   {
        0,
        48,
        72,
        72,
        72,
        72,
        48,
        0 
          },

 /*  Letter_P */   {
        0,
        120,
        72,
        120,
        64,
        64,
        64,
        0 
          },

 /*  Letter_Q */   {
        0,
        248,
        136,
        136,
        168,
        152,
        252,
        0 
          },

 /*  Letter_R */   {
        0,
        120,
        72,
        120,
        112,
        88,
        72,
        0 
          },

 /*  Letter_S */   {
        0,
        56,
        64,
        96,
        48,
        8,
        112,
        0 
          },

 /*  Letter_T */   {
        0,
        248,
        32,
        32,
        32,
        32,
        32,
        0
          },

 /*  Letter_U */   {
        0,
        72,
        72,
        72,
        72,
        72,
        120,
        0 
          },

 /*  Letter_V */   {
        0,
        136,
        136,
        136,
        216,
        112,
        32,
        0 
          },

 /*  Letter_W */   {
        0,
        168,
        168,
        168,
        168,
        248,
        0,
        0 
          },

 /*  Letter_X */   {
        0,
        216,
        112,
        112,
        88,
        200,
        0,
        0 
          },

 /*  Letter_Y */   {
        136,
        80,
        80,
        32,
        32,
        32,
        32,
        0 
          },

 /*  Letter_Z */   {
        0,
        248,
        24,
        96,
        64,
        248,
        0,
        0 
          }


    };
    
//00000000000000000000000000000000000000000000000000000000000000000000000000
    
void DrawText ( short X, short Y, const char TextString[], void *VideoMemory, 
                short Mode )
{
     static char c;
     static short i;
     
     i = 0;
     
     do
       {
          c = TextString[i];
          
          if ( c == NULL )
               break;
          else
             {
               c -= DRAWTEXT_START_CHARACTER;
               
               Sprite8 ( X, Y, DRAWTEXT_SPRITE_HEIGHT, ASCII_Array[c].Data, 
                         VideoMemory, Mode );
             
               X += DRAWTEXT_WIDTH;
             }
             
           i++;
       }
     while (1);
}

//00000000000000000000000000000000000000000000000000000000000000000000000000

/*

// Main Function
void _main(void)
{
    clrscr();
    
    InitializeDrawText ( ASCII_Array );
    
    DrawText ( 50, 20, "A BIG FAT STRING", LCD_MEM, SPRT_OR );
    
	  
	 while (1)
	  if ( _keytest ( 0, 4 ) )    // 2nd key pressed
	       break;
}


*/

#endif
