
#ifndef GLOBAL_VARIABLES_DEFINED

#define GLOBAL_VARIABLES_DEFINED

#include "globals.h"


//00000000000000000000000000000000000000000000000000000000000000000000000

     struct GameKeys
       {
         char Up, Down, Left, Right;
         char RotateLeft, RotateRight;
         char Pause, Quit;

       };

//00000000000000000000000000000000000000000000000000000000000000000000000

     struct BlockPic
      {
        char Data[TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH];
      };

//00000000000000000000000000000000000000000000000000000000000000000000000

     struct DroppingBlock
       {
          short x, y;
          short x_Old, y_Old;
          short Xstart, Ystart;

          short MovementCounter;
          short RotationCounter;

          short MovementSpeed;
          short MovementSpeedBackUp;
          short SuperMovementSpeed;

          short RotationSpeed;
          short Type;
          short NextType;
          short RotationIndex;
          short RotationIndexOld;
          short GravityDirection;

          short MaxMovementCount;

          short CollisionBoundaryY;

          char ClearColor;
          
          short MaxPieceTypes;
      };


//00000000000000000000000000000000000000000000000000000000000000000000000

     struct GameKeys MyGameKeys = { 0,0,0,0,0,0,0,0 };
     
     char TetradActionFlag = 0;

//00000000000000000000000000000000000000000000000000000000000000000000000

     static struct DroppingBlock Block_Template_1 = {0};
     static struct DroppingBlock Block_Template_2 = {0};

     #define BLOCK_TEMPLATE_NORMAL     1
     #define BLOCK_TEMPLATE_REVERSE   -1

//00000000000000000000000000000000000000000000000000000000000000000000000
// Tigcc specific

  #define MAX_BLOCK_SPRITES   TETRAD_TYPE_COUNT
  #define SPRITE_SIZE_BYTES   8
  
  struct BlockSprite 
    {
  	  unsigned char Pic[SPRITE_SIZE_BYTES];
    };
    
  static struct BlockSprite MyBlockSprites_A
        [ TETRAD_TYPE_COUNT ] = 
    {
     {   0,   0,   0,   0,   0,   0,   0,   0 },
     { ~192, ~222, ~222, ~222, ~222, ~192, ~255, ~255 }, 
     { ~192, ~222, ~210, ~210, ~222, ~192, ~255, ~255 },
     { ~218, ~245, ~201, ~246, ~235, ~218, ~255, ~255 },
     { ~192, ~192, ~204, ~204, ~192, ~192, ~255, ~255 },
     { ~255, ~225, ~237, ~237, ~225, ~255, ~255, ~255 },
     { ~212, ~193, ~236, ~197, ~224, ~202, ~255, ~255 },
     { ~201, ~202, ~204, ~207, ~208, ~224, ~255, ~255 },
     { ~251, ~225, ~228, ~201, ~225, ~247, ~255, ~255 },
     { ~200, ~210, ~212, ~201, ~230, ~208, ~255, ~255 },
     { ~192, ~222, ~222, ~222, ~222, ~192, ~255, ~255 },
     { ~192, ~222, ~222, ~222, ~222, ~192, ~255, ~255 }

    };
    
  static struct BlockSprite MyBlockSprites_B 
        [ TETRAD_TYPE_COUNT ] = 
    {
    	 {   0,   0,   0,   0,   0,   0,   0,   0 },
    	 {  63,  63,  63,  63,  63,  63,   0,   0 },
    	 {   0,   0,   0,   0,   0,   0,   0,   0 },
    	 {  63,  63,  63,  63,  63,  63,   0,   0 },
    	 {   0,   0,   0,   0,   0,   0,   0,   0 },
    	 {  63,  63,  63,  63,  63,  63,   0,   0 },
    	 {   0,   0,   0,   0,   0,   0,   0,   0 },
    	 {   0,   0,   0,   0,   0,   0,   0,   0 },
    	 {  63,  63,  63,  63,  63,  63,   0,   0 },
    	 {   0,   0,   0,   0,   0,   0,   0,   0 },
    	 {   0,   0,   0,   0,   0,   0,   0,   0 },
    	 {  63,  63,  63,  63,  63,  63,   0,   0 },
    	 {  63,  63,  63,  63,  63,  63,   0,   0 },
    };
  
  
  // For the grayscale routines
  
  void *DarkLayer       = 0;
  void *LightLayer      = 0;
  void *GrayScaleBuffer = 0;
  void *BackGroundLayer = 0;

//00000000000000000000000000000000000000000000000000000000000000000000000

// Used by Field.c 

struct PlayField
{
    char Field[PLAYFIELD_HEIGHT][PLAYFIELD_WIDTH];

    short LeftBoundary;
    short RightBoundary;

    short CorruptArea[PLAYFIELD_WIDTH];

    short  ScoreX;
    short  ScoreY;
    long  ScoreValue;
    char ScoreText[PLAYFIELD_TEXT_LENGTH];
    char ScoreValueString[PLAYFIELD_TEXT_LENGTH];

    short  LevelX;
    short  LevelY;
    short  LevelValue;
    char LevelText[PLAYFIELD_TEXT_LENGTH];
    char LevelValueString[PLAYFIELD_TEXT_LENGTH];

    short  LinesCompletedX;
    short  LinesCompletedY;
    long  LinesValue;
    char LinesText[PLAYFIELD_TEXT_LENGTH];
    char LinesValueString[PLAYFIELD_TEXT_LENGTH];

    short NextTetradX;
    short NextTetradY;
    short NextTetradType;
    
    void* VirtualScreen;
    
    short RowClearCount;
    short High;
    short NextPiece;
};

//00000000000000000000000000000000000000000000000000000000000000000000000

// used by Lines.c

#define MAX_CLEAR_ROWS    5


struct ClearRowsList
{
       short Rows[MAX_CLEAR_ROWS];
       short RowClearCount;
};

//00000000000000000000000000000000000000000000000000000000000000000000000

// used in Mainbloc.c 
//         Field.c 
//         Menu.c

struct GameOptions
{
     short RealFallSpeed;
     short ViewerFallSpeed;
     
     short High;
     short ReverseGravityFlag;
     short AutoSpeedIncreaseFlag;

     short PlayerCount;
     short BackGroundIndex;
     
     short NewPiecesFlag;
     
     short ExitGameFlag;
     
     short GravityDirection; 
     
     short GameState;

};

#define HIGH_GAME_LINES_NEED_CLEARING 50

//00000000000000000000000000000000000000000000000000000000000000000000000
// 
// used in Field.c

enum GamePoints {  POINTS_LINES_COMPLETED_1 =  2,
                   POINTS_LINES_COMPLETED_2 =  4,
                   POINTS_LINES_COMPLETED_3 = 10,
                   POINTS_LINES_COMPLETED_4 = 40,
                };
                  
// used in Field.c and BackDrop.c

#define FIXED_SCORE_X      CELL_WIDTH_PIXELS * 17
#define FIXED_SCORE_Y      CELL_HEIGHT_PIXELS * 1


//00000000000000000000000000000000000000000000000000000000000000000000000

// used in Misc.c

#define AUTO_SPEED_INCREMENT_INTERVAL          1
#define DROP_SPEED_ADJUSTMENT                  10

//00000000000000000000000000000000000000000000000000000000000000000000000

// used by struct GameState

enum GameStates 
     {
         GAME_OKAY,
         GAME_STATE_WIN,
         GAME_STATE_LOSE,
         GAME_STATE_QUIT
     };

//00000000000000000000000000000000000000000000000000000000000000000000000
//
// Special effects flags/variables
//

     short gXFlip       = 0;
     short gYFlip       = 0;
     short gXDistort    = 0;
     short gYDistort    = 0;
     short gGrayScale   = 1;
     short gShapeMorph  = 0;
     short gShake       = 0;
     short gHolePunch   = 0;
     short gSpriteMorph = 0;
     short gXLean       = 0;
     short gYLean       = 0;
     short gMirage1     = 0;
     short gMirage2     = 0;
     short gTetradRain  = 0;
     short gCellRain    = 0;
     short gExplosion   = 0;
     short gJerking     = 0;
     short gSwapLayers  = 0;
     short gSuperSpeed  = 0;


//00000000000000000000000000000000000000000000000000000000000000000000000
#endif
