// C Source File
// Created 12/17/04; 12:14:26 PM

/*

#define USE_TI89              // Compile for TI-89

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

*/

#ifndef MENU_C_DEFINED

      #define MENU_C_DEFINED

#include <sprites.h>
#include <gray.h>
#include <alloc.h>
#include <stdlib.h>
#include <compat.h>
#include <graph.h>
#include <kbd.h>
#include <mem.h>
#include <string.h>
#include <stdio.h>

#include "glob_var.h" 

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

#define TITLE_WIDTH_CELLS  26
#define TITLE_HEIGHT_CELLS 10
#define TITLE_CELL_WIDTH   6
#define TITLE_CELL_HEIGHT  6
#define EMPTY_TITLE_CELL   0

#define MAX_BACK_GROUNDS   6
#define BACK_GROUND_1      "TREES"
#define BACK_GROUND_2      "FLAKES"
#define BACK_GROUND_3      "FISH"
#define BACK_GROUND_4      "BRICKS"
#define BACK_GROUND_5      "MONSTERS"
#define BACK_GROUND_6      "NONE   "

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

enum MenuKeys { MENU_NO_KEY, MENU_KEY_UP, MENU_KEY_DOWN, MENU_KEY_LEFT,
                MENU_KEY_RIGHT, MENU_KEY_CLEAR, MENU_KEY_2ND,
                MENU_KEY_F1, MENU_KEY_F2, MENU_KEY_EXTRA_OPTIONS };
                
enum MainMenuOptions { ONE_PLAYER_GAME, TWO_PLAYER_GAME,
                       GAME_OPTIONS, HIGH_SCORES, EXIT_GAME };
                       
                      
enum GameOptionConstants { MAX_GAME_OPTIONS = 6,
                           TYPE_YES_NO = 0,
                           TYPE_INTEGER = 1,
                           TYPE_STRING = 2,
                           STRING_LENGTH = 30,
                           BACK_GROUND_COUNT = MAX_BACK_GROUNDS,
                           
                           UPPER_FALL_SPEED = 9,
                           LOWER_FALL_SPEED = 1,
                           UPPER_GARBAGE_HIGH = 15,
                           LOWER_GARBAGE_HIGH = 0,
                           UPPER_BACK_GROUND = MAX_BACK_GROUNDS - 1,
                           LOWER_BACK_GROUND = 0,
                           
                           FALL_SPEED_ADJUSTMENT = 10
                            }; 

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

     // Used by struct PseudGameOptions 
     
     struct SimpleString
       {
          char Data[STRING_LENGTH];
       };
       
     // Used by GameOptionMenu () and 
     // DisplayPseudoGameOptionsValues()

     struct PseudoGameOptions
       {
          short DataType [MAX_GAME_OPTIONS];
          short DataLowerBound [MAX_GAME_OPTIONS];
          short DataUpperBound [MAX_GAME_OPTIONS];
          short Data [MAX_GAME_OPTIONS];
          short LocationX[MAX_GAME_OPTIONS];
          short LocationY[MAX_GAME_OPTIONS];
          
          struct SimpleString BackGroundNames [BACK_GROUND_COUNT];  
       };    

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

/*

struct GameOptions
{
     short RealFallSpeed;
     short ViewerFallSpeed;
     
     short High;
     short ReverseGravityFlag;
     short AutoSpeedIncreaseFlag;

     short PlayerCount;
     short BackGroundIndex;
     
     short NewPiecesFlag;
     
     short ExitGameFlag;
     
     short GravityDirection; 

};

*/

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

unsigned const char TitleCells [][TITLE_WIDTH_CELLS] = 
     {
     	  { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0 },
     	  { 2,2,2,2,0,1,0,1,0,2,0,0,1,1,0,2,0,1,1,0,0,2,0,1,1,1 },
     	  { 2,0,0,2,0,1,0,1,2,0,2,0,1,0,1,2,0,1,0,1,0,2,0,1,0,0 },
     	  { 2,0,0,2,0,1,0,1,2,2,2,0,1,0,1,2,0,1,1,1,0,2,0,1,1,1 },
     	  { 2,0,0,2,0,1,0,1,2,0,2,0,1,0,1,2,0,1,1,0,0,2,0,0,0,1 },
     	  { 2,2,2,2,0,1,1,1,2,0,2,0,1,1,0,2,0,1,0,1,0,2,0,1,1,1 },
     	  { 0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
     	  { 0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
     	  { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
     	  { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
     };

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*     
//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void DrawCell0 ( short CellX, short CellY, char Color, void *Buffer );
void DisplayTitle ( char *DataSource, void *VideoMemoryPointer );
void DoTitle ();

enum MainMenuOptions MainMenuScreen ();
enum MenuKeys MenuWaitKey ( short LoopDelay );
void InterpreteMainMenuOptions ( short Option, struct GameOptions* MyGameOptions );
void GameOptionMenu ( struct GameOptions* MyGameOptions );

void InitializeGameOptions ( struct GameOptions* MyGameOptions);

void ExtraOptionsScreen ();
void ToggleOption ( short *OptionValue, const short MaxValue, 
                    short ChangeDirection );

void DrawOptionValue ( const short X, const short Y, const short OptionValue,
                       const short MaxValue );                    
                   
void GetGlobalSpecialEffectsVariables ( short *VariableArray );
  
void SetGlobalSpecialEffectsVariables ( short *VariableArray );

//------------------------------------------------------------------------------------
// Used only by GameOptionMenu()


void InitializePseudoGameOptions ( struct PseudoGameOptions* MyPseudoGameOptions );

void CopyGameOptions2PseudoGameOptions ( struct PseudoGameOptions* MyPseudoGameOptions,
                                         struct GameOptions* MyGameOptions);

void CopyPseudoGameOptions2GameOptions ( struct PseudoGameOptions* MyPseudoGameOptions,
                                        struct GameOptions* MyGameOptions);

void DisplayPseudoGameOptionValues ( struct PseudoGameOptions*
                                      MyPseudoGameOptions );
                                                                              
void AdjustGameOption ( struct PseudoGameOptions* MyPseudoGameOptions,
                        short CursorIndex, short ChangeDirection );

//------------------------------------------------------------------------------------                                       

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*
//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void DrawCell0 ( short CellX, short CellY, char Color, void *Buffer )
{
     static unsigned char CellSprite1 [] = { 63, 33, 33, 33, 33, 63, 0, 0 };
     static unsigned char CellSprite2 [] = { 63, 42, 21, 42, 21, 63, 0, 0 };

     char *Source;
     
     if ( Color == 1 )
          Source = CellSprite1;
     else
     if ( Color == 2 )
          Source = CellSprite2;

     Sprite8 ( CellX * TITLE_CELL_WIDTH,
               CellY * TITLE_CELL_HEIGHT, 
               TITLE_CELL_HEIGHT, 
               Source, 
               Buffer, 
               SPRT_OR); 
     
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*
   
void DisplayTitle ( char *DataSource, void *VideoMemoryPointer )
{  
	   short Xindex, Yindex;

	   // Display the game's graphical title
	   
	   for ( Yindex = 0; Yindex < TITLE_HEIGHT_CELLS; Yindex++ )
	       for ( Xindex = 0; Xindex < TITLE_WIDTH_CELLS; Xindex++ )
	          if ( *(DataSource + Yindex * TITLE_WIDTH_CELLS + Xindex) 
	                != EMPTY_TITLE_CELL )
	      
	           DrawCell0 ( Xindex, Yindex, 
	                      *(DataSource + Yindex * TITLE_WIDTH_CELLS + Xindex ),
	                       VideoMemoryPointer );
	                    
      DrawStr ( 28, 54, "Programmed by E.Y.", A_REPLACE ); 
      DrawStr ( 40, 80, "Press CLEAR", A_REPLACE ); 
      
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void DoTitle ()
{
	   //void *ScreenBuffer = malloc( LCD_SIZE );

     FontSetSys (F_6x8);   
     //PortSet ( ScreenBuffer, LCD_WIDTH, LCD_HEIGHT );

     clrscr();

     //while (1)
       //{
           //memset (ScreenBuffer, 0, LCD_SIZE);     
           
           DisplayTitle ( (char *)TitleCells, LCD_MEM ); //ScreenBuffer ); 
           
           //memcpy (LCD_MEM, ScreenBuffer, LCD_SIZE );
         
         while (1)  
           if ( _keytest ( 1, 6 ) )   // Check if Clear Button pressed
             break;    
     	 //};
     	 
     //PortRestore();
	   //free ( ScreenBuffer );
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

enum MainMenuOptions MainMenuScreen ()
{

 enum MenuKeys MyMenuKey;
   
 const static short MAX_CURSOR_POSITIONS = 4;

      static short CursorX[] = { 15, 15, 15, 15 };
      static short CursorY[] = { 20, 35, 50, 65 };
             short CursorIndex;
             
      enum MainMenuOptions ReturnValue;
      
      CursorIndex = 0;
  
      FontSetSys (F_6x8);       
	    clrscr();
  
      DrawStr ( 40,  5, "( Main Menu )", A_REPLACE );
      DrawStr ( 28, 20, "Start 1 player game", A_REPLACE ); 
      DrawStr ( 28, 35, "Start 2 player game", A_REPLACE ); 
      DrawStr ( 28, 50, "Options", A_REPLACE );
      DrawStr ( 28, 65, "High Scores", A_REPLACE );
    
  while (1)
    {  
      DrawChar ( CursorX[0], CursorY[0],
                 ' ', A_REPLACE );     
      DrawChar ( CursorX[1], CursorY[1],
                 ' ', A_REPLACE );   
      DrawChar ( CursorX[2], CursorY[2],
                 ' ', A_REPLACE );   
      DrawChar ( CursorX[3], CursorY[3],
                 ' ', A_REPLACE );               
      DrawChar ( CursorX[CursorIndex], CursorY[CursorIndex],
                 '>', A_REPLACE );     

      MyMenuKey = MenuWaitKey(100);
      
      if ( MyMenuKey == MENU_KEY_UP )
           CursorIndex--;
      else
      if ( MyMenuKey == MENU_KEY_DOWN )
           CursorIndex++;
      else
      if ( MyMenuKey == MENU_KEY_F1 ||
           MyMenuKey == MENU_KEY_F2 )
         {
         	 switch ( CursorIndex )
         	   {
         	   	   case 0: ReturnValue = ONE_PLAYER_GAME; 
         	   	           break;
         	   	   case 1: ReturnValue = TWO_PLAYER_GAME;
         	   	           break;
         	   	   case 2: ReturnValue = GAME_OPTIONS;
         	   	           break;
         	   	   case 3: ReturnValue = HIGH_SCORES;
         	   	           break;
         	   	   default:
         	   	           break;
         	   }
         	   break; 
         }
      else
      if ( MyMenuKey == MENU_KEY_2ND )
         {
         	 ReturnValue = EXIT_GAME;
         	 break;
         }
      else
      if ( MyMenuKey == MENU_KEY_EXTRA_OPTIONS )
         {
           ExtraOptionsScreen ();
           
           DrawStr ( 40,  5, "( Main Menu )", A_REPLACE );
           DrawStr ( 28, 20, "Start 1 player game", A_REPLACE ); 
           DrawStr ( 28, 35, "Start 2 player game", A_REPLACE ); 
           DrawStr ( 28, 50, "Options", A_REPLACE );
           DrawStr ( 28, 65, "High Scores", A_REPLACE );
         }
           
      // Add F1 and F2 keys for option selection
      // then break loop      
      
      if ( CursorIndex >= MAX_CURSOR_POSITIONS )
           CursorIndex = MAX_CURSOR_POSITIONS - 1;
      else
      if ( CursorIndex < 0 )
           CursorIndex = 0; 
    }

      return ReturnValue;             
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

enum MenuKeys MenuWaitKey ( short LoopDelay )
{
     enum MenuKeys ReturnValue;
     short KeyPressCount;
     
   do
    {  
     ReturnValue = 0;
     KeyPressCount = 0;
     
     while ( KeyPressCount < LoopDelay )
         {
         	  if ( _keytest ( RR_CLEAR ) )
         	     {
         	      ReturnValue = MENU_KEY_CLEAR;
         	      KeyPressCount++;
         	     }
         	  if ( _keytest ( RR_ENTER ) )     // Quit the game
         	     {
         	      ReturnValue = MENU_KEY_2ND;
         	      KeyPressCount++;
         	     }
         	  if ( _keytest ( RR_F1 ) )
         	     {
         	      ReturnValue = MENU_KEY_F1;
         	      KeyPressCount++;
         	     }         	     
         	  if ( _keytest ( RR_F2) )
         	     {
         	      ReturnValue = MENU_KEY_F2;
         	      KeyPressCount++;
         	     }         	     
         	     
         	  if ( _keytest ( RR_UP ) )
         	     {
         	      ReturnValue = MENU_KEY_UP;
         	      KeyPressCount++;
         	     }         	      
         	  if ( _keytest ( RR_LEFT ) )
         	     {
         	      ReturnValue = MENU_KEY_LEFT;
         	      KeyPressCount++;
         	     }         	           	  
         	  if ( _keytest ( RR_DOWN ) )
         	     {
         	      ReturnValue = MENU_KEY_DOWN;
         	      KeyPressCount++;
         	     }         	      
         	  if ( _keytest ( RR_RIGHT ) )
         	     {
         	      ReturnValue = MENU_KEY_RIGHT;   	  
         	      KeyPressCount++;
         	     }         	  
         	  if ( _keytest ( RR_2ND ) )
         	     {
         	      ReturnValue = MENU_KEY_EXTRA_OPTIONS;
         	      KeyPressCount++;
         	     }
         } 
         
       }
     while ( KeyPressCount == 0 );   

    return ReturnValue;
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void InterpreteMainMenuOptions ( short Option, struct GameOptions* MyGameOptions )
{
	   switch ( Option )
	    {
	    	  case ONE_PLAYER_GAME: MyGameOptions->PlayerCount = 1;
	    	                        break;
	    	  case TWO_PLAYER_GAME: MyGameOptions->PlayerCount = 2;
	    	                        break;
	    	  case GAME_OPTIONS:   GameOptionMenu( MyGameOptions );
	    	                       break;
	    	  case HIGH_SCORES:    // DisplayHighScores ( struct HighScores *MyHighScores );
	    	                       break;
	    	  case EXIT_GAME:      MyGameOptions->ExitGameFlag = TRUE;
	    	  default:
	    	           break;
	    }
}


//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void GameOptionMenu ( struct GameOptions* MyGameOptions )
{

/*
     enum GameOptionConstants { MAX_GAME_OPTIONS = 5,
                                TYPE_YES_NO = 0,
                                TYPE_INTEGER = 1,
                                TYPE_STRING = 2,
                                STRING_LENGTH = 30,
                                BACK_GROUND_COUNT = MAX_BACK_GROUNDS }; 

*/
     
            short LoopIndex;
            short CursorIndex;
     static short CursorX [MAX_GAME_OPTIONS] = { 15, 15, 15, 15, 15, 15 };
     static short CursorY [MAX_GAME_OPTIONS] = { 20, 30, 40, 50, 60, 70 };
            short MyMenuKey;

    //------------------------------------------------------------------

/*
     struct SimpleString
       {
          char Data[STRING_LENGTH];
       };

     struct PseudoGameOptions
       {
          short DataType [MAX_GAME_OPTIONS];
          short DataLowerBound [MAX_GAME_OPTIONS];
          short DataUpperBound [MAX_GAME_OPTIONS];
          short Data[MAX_GAME_OPTIONS];
          short LocationX[MAX_GAME_OPTIONS];
          short LocationY[MAX_GAME_OPTIONS];
            
          struct SimpleString BackGroundNames [BACK_GROUND_COUNT];  
       };    
*/
      struct PseudoGameOptions MyPseudoGameOptions;

      InitializePseudoGameOptions ( &MyPseudoGameOptions );
      CopyGameOptions2PseudoGameOptions ( &MyPseudoGameOptions, MyGameOptions );

	   clrscr();
	   
	   CursorIndex = 0;
	   
	   FontSetSys (F_6x8);   
	   
	   
	while (1)
	  {
	   
	   // Erase previously drawn cursors
	   
	   for ( LoopIndex = 0; LoopIndex < MAX_GAME_OPTIONS; LoopIndex++ )
	         DrawChar ( CursorX[LoopIndex], CursorY[LoopIndex],
	                    ' ', A_REPLACE );
	   
	   // Display Cursor
	   
	    DrawChar ( CursorX[CursorIndex], CursorY[CursorIndex],
	               '>', A_REPLACE );
	               
	      
	   // Display all options
	   
	    DrawStr ( 40,  5, "( Game Options )", A_REPLACE );
      DrawStr ( 28, 20, "Speed", A_REPLACE ); 
      DrawStr ( 28, 30, "High", A_REPLACE ); 
      DrawStr ( 28, 40, "AutoSpeed", A_REPLACE );
      DrawStr ( 28, 50, "Reverse G", A_REPLACE );
      DrawStr ( 28, 60, "Background", A_REPLACE );
	    DrawStr ( 28, 70, "New Pieces", A_REPLACE );
	    
	   // Display values right of option text
	   
	   DisplayPseudoGameOptionValues ( &MyPseudoGameOptions );


	    MyMenuKey = MenuWaitKey (100);
	    
	    switch ( MyMenuKey )
	      {
	           case MENU_KEY_UP:   CursorIndex--;
	                               if ( CursorIndex < 0 )
	                                    CursorIndex = 0;  
	                               break;
	           case MENU_KEY_DOWN: CursorIndex++;
	                               if ( CursorIndex >= MAX_GAME_OPTIONS )
	                                    CursorIndex = MAX_GAME_OPTIONS - 1;
	                                break;
	           case MENU_KEY_LEFT: 
                     
                     AdjustGameOption ( &MyPseudoGameOptions,
                     CursorIndex, -1 );
                     break;
                     
	           case MENU_KEY_RIGHT:

                     AdjustGameOption ( &MyPseudoGameOptions,
                     CursorIndex, 1 );
                     break;
                     
	           case MENU_KEY_CLEAR:
	           default:
	                    break;
	      };

        if ( MyMenuKey == MENU_KEY_CLEAR )  // exit menu
             break;                

    }
    
      CopyPseudoGameOptions2GameOptions ( &MyPseudoGameOptions, MyGameOptions );
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void InitializePseudoGameOptions ( struct PseudoGameOptions* MyPseudoGameOptions )
{
    //------------------------------------------------------------------
    
       strcpy ( MyPseudoGameOptions->BackGroundNames[0].Data, BACK_GROUND_1 );
       strcpy ( MyPseudoGameOptions->BackGroundNames[1].Data, BACK_GROUND_2 );
       strcpy ( MyPseudoGameOptions->BackGroundNames[2].Data, BACK_GROUND_3 );
       strcpy ( MyPseudoGameOptions->BackGroundNames[3].Data, BACK_GROUND_4 );
       strcpy ( MyPseudoGameOptions->BackGroundNames[4].Data, BACK_GROUND_5 );
       strcpy ( MyPseudoGameOptions->BackGroundNames[5].Data, BACK_GROUND_6 );
       
       MyPseudoGameOptions->DataType[0] = TYPE_INTEGER;   // speed
       MyPseudoGameOptions->DataType[1] = TYPE_INTEGER;   // high
       MyPseudoGameOptions->DataType[2] = TYPE_YES_NO;    // autospeed
       MyPseudoGameOptions->DataType[3] = TYPE_YES_NO;    // reverse gravity
       MyPseudoGameOptions->DataType[4] = TYPE_STRING;    // background
       MyPseudoGameOptions->DataType[5] = TYPE_YES_NO;    // new pieces
       
       MyPseudoGameOptions->DataLowerBound[0] = LOWER_FALL_SPEED;     
       MyPseudoGameOptions->DataLowerBound[1] = LOWER_GARBAGE_HIGH;     
       MyPseudoGameOptions->DataLowerBound[4] = LOWER_BACK_GROUND;  
       
       MyPseudoGameOptions->DataUpperBound[0] = UPPER_FALL_SPEED;     
       MyPseudoGameOptions->DataUpperBound[1] = UPPER_GARBAGE_HIGH;     
       MyPseudoGameOptions->DataUpperBound[4] = UPPER_BACK_GROUND;    
       

       MyPseudoGameOptions->LocationY[0] = 20;      
       MyPseudoGameOptions->LocationY[1] = 30;     
       MyPseudoGameOptions->LocationY[2] = 40;     
       MyPseudoGameOptions->LocationY[3] = 50;     
       MyPseudoGameOptions->LocationY[4] = 60;  
       MyPseudoGameOptions->LocationY[5] = 70;
       
       MyPseudoGameOptions->LocationX[0] = 100;      
       MyPseudoGameOptions->LocationX[1] = 100;     
       MyPseudoGameOptions->LocationX[2] = 100;     
       MyPseudoGameOptions->LocationX[3] = 100;     
       MyPseudoGameOptions->LocationX[4] = 100;
       MyPseudoGameOptions->LocationX[5] = 100;                   
    
    //------------------------------------------------------------------
}


//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void CopyGameOptions2PseudoGameOptions ( struct PseudoGameOptions* MyPseudoGameOptions,
                                         struct GameOptions* MyGameOptions)
{
     MyPseudoGameOptions->Data[0] = MyGameOptions->ViewerFallSpeed;
     MyPseudoGameOptions->Data[1] = MyGameOptions->High;
     MyPseudoGameOptions->Data[2] = MyGameOptions->AutoSpeedIncreaseFlag;
     MyPseudoGameOptions->Data[3] = MyGameOptions->ReverseGravityFlag;
     MyPseudoGameOptions->Data[4] = MyGameOptions->BackGroundIndex;    
     MyPseudoGameOptions->Data[5] = MyGameOptions->NewPiecesFlag; 
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void CopyPseudoGameOptions2GameOptions ( struct PseudoGameOptions* MyPseudoGameOptions,
                                        struct GameOptions* MyGameOptions)
{

     MyGameOptions->ViewerFallSpeed = MyPseudoGameOptions->Data[0];
     MyGameOptions->RealFallSpeed = FALL_SPEED_ADJUSTMENT - MyPseudoGameOptions->Data[0];
     
     MyGameOptions->High = MyPseudoGameOptions->Data[1];
     MyGameOptions->AutoSpeedIncreaseFlag = MyPseudoGameOptions->Data[2];
     MyGameOptions->ReverseGravityFlag = MyPseudoGameOptions->Data[3];
     MyGameOptions->BackGroundIndex = MyPseudoGameOptions->Data[4]; 
     MyGameOptions->NewPiecesFlag = MyPseudoGameOptions->Data[5]; 
     
     if ( MyPseudoGameOptions->Data[3] == 1 )
          MyGameOptions->GravityDirection =  BLOCK_TEMPLATE_REVERSE;
     else
          MyGameOptions->GravityDirection =  BLOCK_TEMPLATE_NORMAL;

}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void InitializeGameOptions ( struct GameOptions* MyGameOptions)
{
	   MyGameOptions->High = 0;
	   MyGameOptions->PlayerCount = 1;
	   MyGameOptions->BackGroundIndex = 0;
	   MyGameOptions->AutoSpeedIncreaseFlag = 0;
	   MyGameOptions->RealFallSpeed = 5;
	   MyGameOptions->ViewerFallSpeed = 
	        FALL_SPEED_ADJUSTMENT - MyGameOptions->RealFallSpeed;
	   
	   MyGameOptions->ReverseGravityFlag = 0;
	   MyGameOptions->NewPiecesFlag = 0;
	   
	   MyGameOptions->GravityDirection =  BLOCK_TEMPLATE_NORMAL;
	   
	   MyGameOptions->GameState = GAME_OKAY;
	       
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void DisplayPseudoGameOptionValues ( struct PseudoGameOptions*
                                      MyPseudoGameOptions )
{
     short Index, X, Y;
     short Data, DataType;
     short DataUpperBound, DataLowerBound;
     
     char StringBuffer [STRING_LENGTH];
     
     // enum Fonts {F_4x6, F_6x8, F_8x10};
     
     FontSetSys ( F_6x8 );
     
     
     for ( Index = 0; Index < MAX_GAME_OPTIONS; Index++ )
         {
              X = MyPseudoGameOptions->LocationX [Index];
              Y = MyPseudoGameOptions->LocationY [Index];
              
              DataType = MyPseudoGameOptions->DataType[Index];
              Data     = MyPseudoGameOptions->Data[Index];
              
            if ( DataType == TYPE_INTEGER )
              sprintf( StringBuffer, "%d  ", 
                       MyPseudoGameOptions->Data[Index]);
            else
            if ( DataType == TYPE_YES_NO )
               {
                 if ( Data == 0 )
                     sprintf( StringBuffer, "FALSE " );
                 else
                 if ( Data == 1 )
                      sprintf( StringBuffer, "TRUE " ); 
               }
            else
            if ( DataType == TYPE_STRING )         
               {
                 sprintf( StringBuffer, "%s  ",
                        MyPseudoGameOptions->
                        BackGroundNames[Data].Data );
                          
               }
               
            DrawStr (X, Y, StringBuffer, A_REPLACE);    
         }
}      

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void AdjustGameOption ( struct PseudoGameOptions* MyPseudoGameOptions,
                        short CursorIndex, short ChangeDirection )
{
     short Data, DataType, UpperBound, LowerBound;
     
     Data = MyPseudoGameOptions->Data[CursorIndex];
     
     DataType = MyPseudoGameOptions->DataType[CursorIndex];
     
     UpperBound =  MyPseudoGameOptions->DataUpperBound[CursorIndex];
     
     LowerBound =  MyPseudoGameOptions->DataLowerBound[CursorIndex];
     
     if ( DataType == TYPE_YES_NO && Data == 0 )
          Data = 1;
     else
     if ( DataType == TYPE_YES_NO && Data == 1 )
          Data = 0;
     else         
     if ( ChangeDirection < 0 )
        { 
          if ( Data > LowerBound )
               Data--;        
        }
     else
     if ( ChangeDirection > 0 )
        {
          if ( Data < UpperBound )
               Data++;
        }
    
    MyPseudoGameOptions->Data[CursorIndex] = Data;
    
}                              

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void ExtraOptionsScreen ()
{
      short CursorIndex, MyMenuKey, CursorEraseY;
      short OptionValueShowIndex;
      
      #define MAX_CURSOR_POSITIONS 19
       
      static const short CursorX = 15;
      static const short OPTION_VALUE_SHOW_X = 100;
      static const short CursorY[MAX_CURSOR_POSITIONS] = 
        { 20, 30, 40, 50, 60, 70,
          20, 30, 40, 50, 60, 70,
          20, 30, 40, 50, 60, 70,
          20 };
      static short ExtraOptionsValues[MAX_CURSOR_POSITIONS] =
        {  0,  0,  0,  0,  0,  0,  0,
           0,  0,  0,  0,  0,  0,  0,
           0,  0,  0,  0,  0
        };
      static const short ExtraOptionsValuesMAX[MAX_CURSOR_POSITIONS] =
        {  2,  2,  PLAYFIELD_WIDTH-1, PLAYFIELD_HEIGHT-1,  1, 1,  1,
           1,  1,  PLAYFIELD_WIDTH-1, PLAYFIELD_HEIGHT-1 , 1,  1,  1,
           1,  1, 1, 1, 1
        };
      
      FontSetSys (F_6x8);       
      
      CursorIndex = 0;
      
      GetGlobalSpecialEffectsVariables ( ExtraOptionsValues );
      
      clrscr();
   
  while(1)
    {
	    //clrscr();
	    
	   if ( CursorIndex < 6 )
	      {  
	    DrawStr ( 40,  5, "( Extra Options )", A_REPLACE );
      DrawStr ( 28, 20, "X-flip      ", A_REPLACE ); 
      DrawStr ( 28, 30, "Y-flip      ", A_REPLACE ); 
      DrawStr ( 28, 40, "X-distort   ", A_REPLACE );
      DrawStr ( 28, 50, "Y-distort   ", A_REPLACE );
      DrawStr ( 28, 60, "GrayScale   ", A_REPLACE );
	    DrawStr ( 28, 70, "Shape morph ", A_REPLACE );
	    DrawStr ( 28, 80, "More...     ", A_REPLACE );

      for ( OptionValueShowIndex = 0; OptionValueShowIndex < 6;
            OptionValueShowIndex++ )
            DrawOptionValue ( OPTION_VALUE_SHOW_X, CursorY[OptionValueShowIndex], 
                              ExtraOptionsValues[OptionValueShowIndex],
                              ExtraOptionsValuesMAX[OptionValueShowIndex] );                 
	       }
	   else
	   if ( 6 <= CursorIndex && CursorIndex < 12 )
	      {
	    DrawStr ( 40,  5, "( Extra Options )", A_REPLACE );
      DrawStr ( 28, 20, "Shake       ", A_REPLACE ); 
      DrawStr ( 28, 30, "Hole punch  ", A_REPLACE ); 
      DrawStr ( 28, 40, "Sprite morph", A_REPLACE );
      DrawStr ( 28, 50, "X-lean      ", A_REPLACE );
      DrawStr ( 28, 60, "Y-lean      ", A_REPLACE );
	    DrawStr ( 28, 70, "Mirage #1   ", A_REPLACE );
	    DrawStr ( 28, 80, "More...     ", A_REPLACE );

      for ( OptionValueShowIndex = 6; OptionValueShowIndex < 12;
            OptionValueShowIndex++ )
            DrawOptionValue ( OPTION_VALUE_SHOW_X, CursorY[OptionValueShowIndex], 
                              ExtraOptionsValues[OptionValueShowIndex],
                              ExtraOptionsValuesMAX[OptionValueShowIndex] );     
	       }
	   else
	   if ( 12 <= CursorIndex && CursorIndex < 18 )
	      { 
	    DrawStr ( 40,  5, "( Extra Options )", A_REPLACE );
      DrawStr ( 28, 20, "Mirage #2   ", A_REPLACE ); 
      DrawStr ( 28, 30, "Tetrad Rain ", A_REPLACE ); 
      DrawStr ( 28, 40, "Cell Rain   ", A_REPLACE );
      DrawStr ( 28, 50, "Explosion   ", A_REPLACE );
      DrawStr ( 28, 60, "Jerking     ", A_REPLACE );
      DrawStr ( 28, 70, "Swap Layers ", A_REPLACE );     
      DrawStr ( 28, 80, "More...     ", A_REPLACE );     
      
      for ( OptionValueShowIndex = 12; OptionValueShowIndex < 18;
            OptionValueShowIndex++ )
            DrawOptionValue ( OPTION_VALUE_SHOW_X, CursorY[OptionValueShowIndex], 
                              ExtraOptionsValues[OptionValueShowIndex],
                              ExtraOptionsValuesMAX[OptionValueShowIndex] );     
        }
	   else
	   if ( 18 <= CursorIndex && CursorIndex < MAX_CURSOR_POSITIONS )
	      { 
	    DrawStr ( 40,  5, "( Extra Options )", A_REPLACE );
      DrawStr ( 28, 20, "Super Speed  ", A_REPLACE ); 
      DrawStr ( 28, 30, "                     ", A_REPLACE ); 
      DrawStr ( 28, 40, "                     ", A_REPLACE );
      DrawStr ( 28, 50, "                     ", A_REPLACE );
      DrawStr ( 28, 60, "                     ", A_REPLACE );
      DrawStr ( 28, 70, "                     ", A_REPLACE );     
      DrawStr ( 28, 80, "                     ", A_REPLACE );     
      
      for ( OptionValueShowIndex = 18; OptionValueShowIndex < MAX_CURSOR_POSITIONS;
            OptionValueShowIndex++ )
            DrawOptionValue ( OPTION_VALUE_SHOW_X, CursorY[OptionValueShowIndex], 
                              ExtraOptionsValues[OptionValueShowIndex],
                              ExtraOptionsValuesMAX[OptionValueShowIndex] );     
        }
        
     // Clear all cursor positions 
        
     for ( CursorEraseY = 20; CursorEraseY <= 80; CursorEraseY++  )
	         DrawStr ( CursorX, CursorEraseY, " ", A_REPLACE );            
    
     // Draw the cursor
     
     DrawStr ( CursorX, CursorY[CursorIndex], ">", A_REPLACE ); 
     
     	    MyMenuKey = MenuWaitKey(100);
	    
	    if ( MyMenuKey == MENU_KEY_UP )
	         CursorIndex--;
	    else
	    if ( MyMenuKey == MENU_KEY_DOWN )
	         CursorIndex++;
	    else
	    if ( MyMenuKey == MENU_KEY_RIGHT )
	         ToggleOption ( &ExtraOptionsValues[CursorIndex],
	                         ExtraOptionsValuesMAX[CursorIndex],
	                         1 );
	    else
	    if ( MyMenuKey == MENU_KEY_LEFT )
	         ToggleOption ( &ExtraOptionsValues[CursorIndex],
	                         ExtraOptionsValuesMAX[CursorIndex],
	                         -1 );
	    else                      // Exit the extra options menu
	    if ( MyMenuKey == MENU_KEY_CLEAR )
	         break;  
	       
	    if ( CursorIndex < 0 )  
	         CursorIndex = 0;
	    if ( CursorIndex >= MAX_CURSOR_POSITIONS )
	         CursorIndex = MAX_CURSOR_POSITIONS - 1;
	         	    
     }
     
     SetGlobalSpecialEffectsVariables ( ExtraOptionsValues );
     
           clrscr();
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void ToggleOption ( short *OptionValue, const short MaxValue, 
                    short ChangeDirection )
{
     if ( ChangeDirection < 0 )
          (*OptionValue)--;
     else
     if ( ChangeDirection > 0 )
          (*OptionValue)++;
          
     if ( *OptionValue < 0 )
          *OptionValue = MaxValue;
     else
     if ( *OptionValue > MaxValue )
          *OptionValue = 0;
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void DrawOptionValue ( const short X, const short Y, const short OptionValue,
                       const short MaxValue )                    
{
   static char Buffer[10];
  
   if ( MaxValue == 2 )
      {
         switch (OptionValue)
           {
               case 0: sprintf ( Buffer, "%s", "FALSE" ); 
                       break;
               case 1: sprintf ( Buffer, "%s", "TRUE " ); 
                       break;
               case 2: 
               default: sprintf ( Buffer, "%s", "RAND " ); 
                        break;
           };
      }
   else
   if ( MaxValue == 1 )
      {
         switch (OptionValue)
           {
               case 0: sprintf ( Buffer, "%s", "FALSE" ); 
                       break;
               case 1: 
               default: sprintf ( Buffer, "%s", "TRUE " ); 
                        break;
           };
      }
   else
      sprintf ( Buffer, "%5d", OptionValue );

   DrawStr ( X, Y, Buffer, A_REPLACE );
   
}
                   
//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void GetGlobalSpecialEffectsVariables ( short *VariableArray )
{
     VariableArray[0] = gXFlip;
     VariableArray[1] = gYFlip;
     VariableArray[2] = gXDistort;
     VariableArray[3] = gYDistort;
     VariableArray[4] = gGrayScale;
     VariableArray[5] = gShapeMorph;
     VariableArray[6] = gShake;
     VariableArray[7] = gHolePunch;
     VariableArray[8] = gSpriteMorph;
     VariableArray[9] = gXLean;
     VariableArray[10] = gYLean;
     VariableArray[11] = gMirage1;
     VariableArray[12] = gMirage2;
     VariableArray[13] = gTetradRain;
     VariableArray[14] = gCellRain;
     VariableArray[15] = gExplosion;
     VariableArray[16] = gJerking;
     VariableArray[17] = gSwapLayers;
     VariableArray[18] = gSuperSpeed;
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void SetGlobalSpecialEffectsVariables ( short *VariableArray )
{
     gXFlip = VariableArray[0];
     gYFlip = VariableArray[1];
     gXDistort = VariableArray[2];
     gYDistort = VariableArray[3];
     gGrayScale = VariableArray[4];
     gShapeMorph = VariableArray[5];
     gShake = VariableArray[6];
     gHolePunch = VariableArray[7];
     gSpriteMorph = VariableArray[8];
     gXLean = VariableArray[9];
     gYLean = VariableArray[10];
     gMirage1 = VariableArray[11];
     gMirage2 = VariableArray[12];
     gTetradRain = VariableArray[13];
     gCellRain = VariableArray[14];
     gExplosion = VariableArray[15];
     gJerking = VariableArray[16];
     gSwapLayers = VariableArray[17];
     gSuperSpeed = VariableArray[18];
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

/*
void _main(void)
{
      struct GameOptions MyGameOptions;
      short MenuOption;
      
      InitializeGameOptions ( &MyGameOptions );
      
	    DoTitle();
	    
	    while (1)
	      {
          MyGameOptions.ExitFlag = FALSE;
      	  
      	  MenuOption = MainMenuScreen(); 
      	      
	        InterpreteMainMenuOptions ( MenuOption, &MyGameOptions );
          
          if ( MyGameOptions.ExitGameFlag == TRUE )
               break;
	      }
        
}

*/

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

#endif
