// C Source File
// Created 1/8/05; 4:50:05 PM

#ifndef SPECIAL_C_DEFINED

     #define SPECIAL_C_DEFINED

/*
#include "D:\TIGCC\Projects\Blocks\globals.h"
#include "D:\TIGCC\Projects\Blocks\glob_var.h"
*/

#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\globals.h"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\glob_var.h"

#include <stdlib.h>

//0000000000000000000000000000000000000000000000000000000000000000000000000000

static short DistortXTable [PLAYFIELD_HEIGHT][PLAYFIELD_WIDTH] = {{0}};
static short DistortYTable [PLAYFIELD_HEIGHT][PLAYFIELD_WIDTH] = {{0}};

static short DistortXTableBackUp [PLAYFIELD_HEIGHT][PLAYFIELD_WIDTH] = {{0}};
static short DistortYTableBackUp [PLAYFIELD_HEIGHT][PLAYFIELD_WIDTH] = {{0}};

//----------------------------------------------------------------------------

enum SpecialEffectsConstants { RANDOMXYFLIP_CHANCE = 6,
                               RANDOMJERKING_CHANCE = 3,
                               TETRAD_MUTATION_CHANCE = 10,
                               TREMOR_CHANCE = 5,
                               TREMOR_DIRECTION_CHANCE = 3,
                               HOLE_PUNCH_CHANCE = 10,
                               HOLE_PUNCH_SUB_CHANCE = 20,
                               SPRITE_MUTATION_CHANCE = 15,
                               MIRAGE_CHANCE = 30,
                               MIRAGE2_CHANCE = 30,
                               MIRAGE2_CELL_CHANCE = 25 };

//----------------------------------------------------------------------------
                               
#define SWAPS_PER_SPRITE_MORPH  5
                              
static char CellSwapColors[TETRAD_CELL_MAX_COLORS] =
               { 1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 };
               
static short TetradSwapArray[TETRAD_TYPE_COUNT] =
               { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 };

static short TetradSwapArrayClassic[TETRAD_CLASSIC_COUNT] =
               { 0, 1, 2, 3, 4, 5 };
               
static char Mirage2Table [PLAYFIELD_HEIGHT][PLAYFIELD_WIDTH] = {{0}};

//----------------------------------------------------------------------------

#define MAX_TETRAD_RAIN_DROPLETS 10

static short TetradRainX [MAX_TETRAD_RAIN_DROPLETS] = {0};
static short TetradRainY [MAX_TETRAD_RAIN_DROPLETS] = {0};
static short TetradRainSpeed [MAX_TETRAD_RAIN_DROPLETS] = {0}; 
static short TetradRainType [MAX_TETRAD_RAIN_DROPLETS] = {0};   

//----------------------------------------------------------------------------

#define MAX_CELL_RAIN_DROPLETS 15

static short CellRainX [MAX_CELL_RAIN_DROPLETS] = {0};
static short CellRainY [MAX_CELL_RAIN_DROPLETS] = {0};
static short CellRainSpeed [MAX_CELL_RAIN_DROPLETS] = {0}; 
static short CellRainType [MAX_CELL_RAIN_DROPLETS] = {0};  
 
//0000000000000000000000000000000000000000000000000000000000000000000000000000

void InitializeDistortTables ();

void DoInitialSpecialEffects ();

void RandomXYFlip ();

void Do_XFlip ();
void Do_YFlip ();
void Do_XYDistort ();
void Do_XYLean ();

void RandomJerking ( struct DroppingBlock *MyDroppingBlock );
void RandomShapeMorph ( struct DroppingBlock *MyDroppingBlock );
void RandomShake ();
void RandomHolePunch ( struct PlayField *MyPlayField );
void Random_Mirage1 ();

void Generate_Mirage2Table ( short Command );
void Draw_Mirage2Table ();

void InitializeTetradRainTable ();
void MoveTetradRain ();
void DrawTetradRain ( struct BlockPic *BlocksArray );

void InitializeCellRainTable();
void MoveCellRain ();
void DrawCellRain ();

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void DoInitialSpecialEffects ()
{
     InitializeDistortTables ();
     
     if ( gXFlip )
          Do_XFlip();
     if ( gYFlip )
          Do_YFlip();
       
     Do_XYDistort();
     
     Do_XYLean();
     
     Generate_Mirage2Table (0);
     
     InitializeTetradRainTable ();
     
     InitializeCellRainTable ();
     
     // Copy distort tables after all special effects are done
    
    { 
     short X, Y;
     
     for ( Y = 0; Y < PLAYFIELD_HEIGHT; Y++ )
        for ( X = 0; X < PLAYFIELD_WIDTH; X++ )
           {
              DistortXTableBackUp[Y][X] = DistortXTable[Y][X];
              DistortYTableBackUp[Y][X] = DistortYTable[Y][X];
           }     
     }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void InitializeDistortTables ()
{
     short X, Y;
     
     for ( Y = 0; Y < PLAYFIELD_HEIGHT; Y++ )
        for ( X = 0; X < PLAYFIELD_WIDTH; X++ )
           {
              DistortXTable[Y][X] = X;
              DistortYTable[Y][X] = Y;
           }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void RandomXYFlip ()
{
     int X, Y;
     
     if ( gXFlip == 2 )
       if ( !random(RANDOMXYFLIP_CHANCE ) )
          for ( Y = 0; Y < PLAYFIELD_HEIGHT; Y++ )
             for ( X = 0; X < PLAYFIELD_WIDTH; X++ )
                   DistortXTable[Y][X] = PLAYFIELD_WIDTH - DistortXTable[Y][X];
                   
     if ( gYFlip == 2 )
       if ( !random(RANDOMXYFLIP_CHANCE ) )
          for ( Y = 0; Y < PLAYFIELD_HEIGHT; Y++ )
             for ( X = 0; X < PLAYFIELD_WIDTH; X++ )
                   DistortYTable[Y][X] = PLAYFIELD_HEIGHT - DistortYTable[Y][X];
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void Do_XFlip ()
{
     short X, Y, XStandard;
     
     for ( Y = 0; Y < PLAYFIELD_HEIGHT; Y++ )
        for ( X = PLAYFIELD_WIDTH - 1, XStandard = 0; X >= 0; X--,
              XStandard++ )
              DistortXTable[Y][XStandard] = X; 
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void Do_YFlip ()
{
     short X, Y, YStandard;

     for ( Y = PLAYFIELD_HEIGHT - 1, YStandard = 0; Y >= 0; Y--,
              YStandard++ )
        for ( X = 0; X < PLAYFIELD_WIDTH; X++ )
              DistortYTable[YStandard][X] = Y;
   
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void Do_XYDistort ()
{
     short X, Y;
 
     randomize();
     
     for ( Y = 0; Y < PLAYFIELD_HEIGHT; Y++ )
        for ( X = 0; X < PLAYFIELD_WIDTH; X++ )
           {
              DistortXTable[Y][X] += random(gXDistort);
              DistortYTable[Y][X] += random(gYDistort);
              
              if ( DistortXTable[Y][X] < 0 )
                   DistortXTable[Y][X] = 0;
                   
              if ( DistortXTable[Y][X] > PLAYFIELD_WIDTH )
                   DistortXTable[Y][X] = PLAYFIELD_WIDTH -1;
                   
              if ( DistortYTable[Y][X] < 0 )
                   DistortYTable[Y][X] = 0;
                   
              if ( DistortYTable[Y][X] > PLAYFIELD_HEIGHT-1 )
                   DistortYTable[Y][X] = PLAYFIELD_HEIGHT-1;
           }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void Do_XYLean ()
{
     short X, Y;
     short LeanXFrequency, LeanYFrequency;
     short LeanXValue, LeanYValue;
     short LeanXIncrement, LeanYIncrement;
     
     if ( gXLean - PLAYFIELD_WIDTH/2 >= 0 )
          LeanXIncrement = 1;
     else
          LeanXIncrement = -1;

     if ( gYLean - PLAYFIELD_HEIGHT/2 >= 0 )
          LeanYIncrement = 1;
     else
          LeanYIncrement = -1;
     
     LeanXFrequency = LeanXIncrement * ( gXLean - PLAYFIELD_WIDTH/2 );
     LeanYFrequency = LeanYIncrement * ( gYLean - PLAYFIELD_HEIGHT/2 );
     
     LeanYValue = LeanXValue = 0;
 
     
     for ( Y = 0; Y < PLAYFIELD_HEIGHT; Y++ )
       {
           if ( !( Y % LeanXFrequency ) ) 
                 LeanXValue += LeanXIncrement;
                  
        for ( X = 0, LeanYValue = 0; X < PLAYFIELD_WIDTH; X++ )
           {
            if ( gXLean )
             DistortXTable[Y][X] += LeanXValue;
           
           if ( gYLean ) 
             DistortYTable[Y][X] += LeanYValue;

             if ( !( X % LeanYFrequency ) ) 
                  LeanYValue += LeanYIncrement;        
                
              if ( DistortXTable[Y][X] < 0 )
                   DistortXTable[Y][X] = 0;
                   
              if ( DistortXTable[Y][X] > PLAYFIELD_WIDTH )
                   DistortXTable[Y][X] = PLAYFIELD_WIDTH -1;
                   
              if ( DistortYTable[Y][X] < 0 )
                   DistortYTable[Y][X] = 0;
                   
              if ( DistortYTable[Y][X] > PLAYFIELD_HEIGHT-1 )
                   DistortYTable[Y][X] = PLAYFIELD_HEIGHT-1;
           }
       }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void RandomJerking ( struct DroppingBlock *MyDroppingBlock )
{
   if ( gJerking )
    if ( !random(RANDOMJERKING_CHANCE) ) 
       {
         MyDroppingBlock->x_Old = MyDroppingBlock->x;
         MyDroppingBlock->y_Old = MyDroppingBlock->y;
          
         if ( !random(2) )
              MyDroppingBlock->y-=1;
         else
              MyDroppingBlock->y+=1;
       }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void RandomShapeMorph ( struct DroppingBlock *MyDroppingBlock )
{
   if ( gShapeMorph )
      if ( !random( TETRAD_MUTATION_CHANCE ))
        MyDroppingBlock->Type = random(MyDroppingBlock->MaxPieceTypes);
   
} 

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void RandomShake ()
{
   if ( gShake )
     if ( !random( TREMOR_CHANCE ))
        {
          short Xdisplace, Ydisplace, X, Y;

          if ( random(TREMOR_DIRECTION_CHANCE ) == 2 )
               Xdisplace = 1;
          else
          if ( random(TREMOR_DIRECTION_CHANCE ) == 1 )
               Xdisplace = -1;
          else
               Xdisplace = 0;
               
          if ( random(TREMOR_DIRECTION_CHANCE ) == 2 )
               Ydisplace = 1;
          else
          if ( random(TREMOR_DIRECTION_CHANCE ) == 1 )
               Ydisplace = -1;
          else
               Ydisplace = 0;
               
     for ( Y = 0; Y < PLAYFIELD_HEIGHT; Y++ )
        for ( X = 0; X < PLAYFIELD_WIDTH; X++ )
           {
              DistortXTable[Y][X] = DistortXTableBackUp[Y][X] + Xdisplace;
              DistortYTable[Y][X] = DistortYTableBackUp[Y][X] + Ydisplace;
              
              if ( DistortXTable[Y][X] < 0 )
                   DistortXTable[Y][X] = 0;
                   
              if ( DistortXTable[Y][X] > PLAYFIELD_WIDTH )
                   DistortXTable[Y][X] = PLAYFIELD_WIDTH -1;
                   
              if ( DistortYTable[Y][X] < 0 )
                   DistortYTable[Y][X] = 0;
                   
              if ( DistortYTable[Y][X] > PLAYFIELD_HEIGHT-1 )
                   DistortYTable[Y][X] = PLAYFIELD_HEIGHT-1;
           }
 
          
        }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void RandomHolePunch( struct PlayField *MyPlayField )

{
  if ( gHolePunch )
   if ( !random (HOLE_PUNCH_CHANCE) )
    {
            short Xindex, Yindex;
            short YStartIndex, YEndIndex;
            short XStartIndex, XEndIndex;

            XStartIndex = PLAYFIELD_WALL_1_X + 1;
            XEndIndex   = PLAYFIELD_WALL_2_X - 1;

            YStartIndex = 0;
            YEndIndex = PLAYFIELD_HEIGHT;

          
      for ( Yindex = YStartIndex; Yindex <= YEndIndex; Yindex++ )
         for ( Xindex = XStartIndex; Xindex <= XEndIndex; Xindex++ )
         
              if ( !random(HOLE_PUNCH_SUB_CHANCE) )
                  MyPlayField->Field[Yindex][Xindex] = EMPTY_CELL_COLOR;
   }

}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void Random_Mirage1 ()
{
    if ( gMirage1 )
      if ( !random(MIRAGE_CHANCE) )
         {
            short SwapIndex1, SwapIndex2;
            short SwapCount;
            short Tetrad1, Tetrad2, TempTetrad;
            
            for ( SwapCount = 0; SwapCount < SWAPS_PER_SPRITE_MORPH; SwapCount++ )
                {
                  // unconventional pieces
                  
                  SwapIndex1 = random(TETRAD_TYPE_COUNT);
                  SwapIndex2 = random(TETRAD_TYPE_COUNT); 
                  
                  Tetrad1 = TetradSwapArray[SwapIndex1];
                  Tetrad2 = TetradSwapArray[SwapIndex2];
                  
                  TempTetrad = Tetrad1;
                  Tetrad1 = Tetrad2;
                  Tetrad2 = TempTetrad;
                  
                  TetradSwapArray[SwapIndex1] = Tetrad1;
                  TetradSwapArray[SwapIndex2] = Tetrad2;
                  
                  // traditional pieces
                  
                  SwapIndex1 = random(TETRAD_CLASSIC_COUNT);
                  SwapIndex2 = random(TETRAD_CLASSIC_COUNT); 
                  
                  Tetrad1 = TetradSwapArrayClassic[SwapIndex1];
                  Tetrad2 = TetradSwapArrayClassic[SwapIndex2];
                  
                  TempTetrad = Tetrad1;
                  Tetrad1 = Tetrad2;
                  Tetrad2 = TempTetrad;
                  
                  TetradSwapArray[SwapIndex1] = Tetrad1;
                  TetradSwapArray[SwapIndex2] = Tetrad2;
                }
        }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void Generate_Mirage2Table ( short Command )
{
   short X, Y;
   char Cell;
   
   if ( Command == 1 )  // generate new table
      {
        if ( gMirage2 )
          if ( !random(MIRAGE2_CHANCE) )
           {
             for ( Y = 0; Y < PLAYFIELD_HEIGHT; Y++ )
               for ( X = PLAYFIELD_WALL_1_X + 1;
                     X < PLAYFIELD_WALL_2_X - 1; X++ )
                                     
                  if ( !random(MIRAGE2_CELL_CHANCE) )
                    Mirage2Table [Y][X] = random(TETRAD_CELL_MAX_COLORS) + 1;       
                  else
                    Mirage2Table [Y][X] = EMPTY_CELL_COLOR;    
           }
         
      }
   else
   if ( Command == 0 )  // initialize Mirage2Table
      {
         for ( Y = 0; Y < PLAYFIELD_HEIGHT; Y++ )
           for ( X = 0; X < PLAYFIELD_WIDTH; X++ )
               Mirage2Table [Y][X] = EMPTY_CELL_COLOR;
      }
  
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void Draw_Mirage2Table ()
{
     short Xindex, Yindex, DestXindex, DestYindex;
     char BlockColor;

   if ( gMirage2 )
     for ( Yindex = 0; Yindex < PLAYFIELD_HEIGHT; Yindex++ )
           for ( Xindex = PLAYFIELD_WALL_1_X + 1;
                 Xindex < PLAYFIELD_WALL_2_X - 1; Xindex++ )
            {
              BlockColor = Mirage2Table[Yindex][Xindex];

            if ( BlockColor != EMPTY_CELL_COLOR )
              DrawCell_Special ( Xindex, Yindex, BlockColor );

             }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void InitializeTetradRainTable ()
{   
   short Index;
   
   for ( Index = 0; Index < MAX_TETRAD_RAIN_DROPLETS; Index++ )
       {
         TetradRainX [Index] = random(PLAYFIELD_WIDTH);
         TetradRainY [Index] = random(PLAYFIELD_HEIGHT);
         TetradRainSpeed[Index] = random(3) + 1;
         TetradRainType[Index] = random(TETRAD_TYPE_COUNT);
       }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void MoveTetradRain ()
{
   short Index;
   
  if ( gTetradRain )
   for ( Index = 0; Index < MAX_TETRAD_RAIN_DROPLETS; Index++ )
       {
         TetradRainY [Index] += TetradRainSpeed[Index];
         
         if ( TetradRainY[Index] > PLAYFIELD_HEIGHT )
              TetradRainY[Index] = -4;
       }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void DrawTetradRain ( struct BlockPic *BlocksArray )
{
   short Index;

  if ( gTetradRain )
   for ( Index = 0; Index < MAX_TETRAD_RAIN_DROPLETS; Index++ )
      
         DrawTetrad_Special ( 
         
         (char *)(*(BlocksArray +     
                  TetradRainType[Index] *
                  TETRAD_MAX_ROTATIONS
                  + 1 )).Data,
                  
         TetradRainX[Index], TetradRainY[Index], EMPTY_CELL_COLOR );
      
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void InitializeCellRainTable()
{
   short Index;
   
   for ( Index = 0; Index < MAX_TETRAD_RAIN_DROPLETS; Index++ )
       {
         CellRainX [Index] = random(PLAYFIELD_WIDTH);
         CellRainY [Index] = random(PLAYFIELD_HEIGHT);
         CellRainSpeed[Index] = random(3) + 1;
         CellRainType[Index] = random(TETRAD_CELL_MAX_COLORS);
       }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void MoveCellRain ()
{
   short Index;
   
  if ( gCellRain )
   for ( Index = 0; Index < MAX_CELL_RAIN_DROPLETS; Index++ )
       {
         CellRainY [Index] += CellRainSpeed[Index];
         
         if ( CellRainY[Index] > PLAYFIELD_HEIGHT )
              CellRainY[Index] = -4;
       }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

void DrawCellRain ()
{
   short Index;

  if ( gCellRain )
   for ( Index = 0; Index < MAX_CELL_RAIN_DROPLETS; Index++ )
      
        if ( 0 <= CellRainX[Index] && CellRainX[Index] < PLAYFIELD_WIDTH &&
             0 <= CellRainY[Index] && CellRainY[Index] < PLAYFIELD_HEIGHT )
         DrawCell_Special ( CellRainX[Index], CellRainY[Index],
                            CellRainType[Index] );
}

//0000000000000000000000000000000000000000000000000000000000000000000000000000

#endif



